          org 00
yearl      dn  1
yearh      dn  1
month      dn  1
dayl       dn  1
dayh       dn  1      
      org 70h
worktmp    dn 4    ;(㻺ʾã
                   ;worktmp(year low) worktmp+1(year high)
                   ;worktmp+2(week)
;*********************************************
;name:   getweek
;input: yearh yearl(bcd) 
        ;month(hex) dayh dayl(bcd)  
;output: worktmp+2(week)
;*********************************************         
getweek:
       call getfirstday
       andi worktmp,0111b
       sta worktmp+2
       lds worktmp+1,monthtabadr
       lds worktmp+3,0
       mvh worktmp+1
       mrw worktmp+1,month
       mvl worktmp+1
       ldh worktmp+3,@hl
       add* worktmp+2
       call nomoreweek       
       subi worktmp+1,3h     
       jnc noleapyear       ;month<3
       andi worktmp,1000b   
       jz noleapyear        ;no leap year
       inc* worktmp+2       ;is leap year
noleapyear:
       lds worktmp+1,2h     
       lds worktmp+3,0
       mvh worktmp+1
       mrw worktmp+3,dayh   ;   
       addi* worktmp+3,6    
       mvl worktmp+3
       ldh worktmp+3,@hl
       add* worktmp+2
       call nomoreweek       
       mrw worktmp+3,dayl
       add* worktmp+2
       call nomoreweek
       dec* worktmp+2
       jc getweekret
       lds worktmp+2,06h 
getweekret:
       rts      
;*********************************
;name:fetfirstday
;input:year
;output:leap status(worktmp.3)
        ;worktmp(1 month 1 day :week(0~2))       
;***********************************
getfirstday:
       mrw worktmp,yearl
       mrw worktmp+1,yearh 
       addi worktmp,0ah
       adci worktmp+1,0ah
       jnc nomorethan56
       subi* worktmp,06h
       das* worktmp
       sbci* worktmp+1,05h
nomorethan56:
       mvl worktmp
       subi worktmp+1,03h
       jnc loadyearhllow
       subi* worktmp+1,03h
       lds worktmp,0
       mvh worktmp+1
       ldh worktmp,@hl
       rts
loadyearhllow:
       lds worktmp,0
       mvh worktmp+1
       ldl worktmp,@hl
       rts
;*********************************
;name: nomoreweek
;input: realweek
;output:realweek(realweek<=7)
;*********************************
nomoreweek:
       subi* worktmp+2,07h
       jc nomoreweek
       adni* worktmp+2,07h
       rts                     
;table1******leap flag and every year 1 month 1 day is week table
	data   000H,00101110B    ;Leap Year flag and The week of every year's first day  Table
	data   001H,00110001B    ;
	data   002H,11000010B    ;2000-->2055
	data   003H,01100011B
	data   004H,00001100B
	data   005H,00010110B
	data   006H,10100000B
	data   007H,01000001B
	data   008H,01011010B
	data   009H,01100100B
	data   010H,10000101B
	data   011H,00100110B
	data   012H,00111000B
	data   013H,01000010B
	data   014H,11010011B
	data   015H,00000100B
	data   016H,00011101B
	data   017H,00100000B
	data   018H,10110001B
	data   019H,01010010B
	data   020H,01101011B
	data   021H,00000101B
	data   022H,10010110B
	data   023H,00110000B
	data   024H,01001001B
	data   025H,01010011B

	data   026H,00000100B    ;The high nibble of these four bytes
	data   027H,00110101B    ;are be used in week adjust process.
	data   028H,01101110B    ;for every 10 days the week should
	data   029H,00100001B    ;increase data 
;table2********max day of any month data(low nibble) and any month 1 day week(high nibble) 
	data   0E1H,03H
	data   0E2H,30H
	data   0E3H,33H
	data   0E4H,62H
	data   0E5H,13H
	data   0E6H,42H
	data   0E7H,63H
	data   0E8H,23H
	data   0E9H,52H
	data   0EAH,03H
	data   0EBH,32H
	data   0ECH,53H                    